import { diff } from 'deep-diff';

function dataHandler(val, oldVal) {
  console.log({
    val: val,
    oldVal: oldVal
  });
  var updates = val && oldVal ? diff(oldVal, val) : [];

  if (updates.length > 0) {
    console.log(updates);

    if (this.$data._chart) {
      console.log('updating...');

      this.$data._chart.update();
    } else {
      console.log('rendering...');
      this.renderChart(this.chartData, this.options);
    }
  }
}

export var reactiveData = {
  data: function data() {
    return {
      chartData: null
    };
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
};
export var reactiveProp = {
  props: {
    chartData: {
      required: true
    }
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
};
export default {
  reactiveData: reactiveData,
  reactiveProp: reactiveProp
};