import { diff } from 'deep-diff'

function dataHandler (val, oldVal) {
  console.log({ val, oldVal })

  let updates = val && oldVal ? diff(oldVal, val) : []

  if (updates.length > 0) {
    console.log(updates)
    if (this.$data._chart) {
      console.log('updating...')
      this.$data._chart.update()
    } else {
      console.log('rendering...')
      this.renderChart(this.chartData, this.options)
    }
  }
}

export const reactiveData = {
  data () {
    return {
      chartData: null
    }
  },

  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
}

export const reactiveProp = {
  props: {
    chartData: {
      required: true
    }
  },
  watch: {
    'chartData': {
      handler: dataHandler,
      deep: true
    }
  }
}

export default {
  reactiveData,
  reactiveProp
}
